﻿using System.ComponentModel;
using VSMDecoratorPattern.Components;

namespace VSMDecoratorPattern.Decorators
{
    public abstract class TextBoxDecorator : ITextBoxComponent
    {
        protected readonly ITextBoxComponent _component;

        protected TextBoxDecorator(ITextBoxComponent component) 
        {
            _component = component;
        }

        public virtual string Text
        {
            get { return _component.Text; }
            set
            {
                _component.Text = value;
            }
        }

        protected void OnPropertyChanged(string name)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(name));
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }
}
